// Cam04Dlg.cpp : 
// *** orgler electronics "Bozen South Tyrol Italy" *** 

#include "stdafx.h"
#include "Cam04.h"
#include "Cam04Dlg.h"
#include "Win2Dlg.h"

#include "direct.h"  // for directory

#include <vfw.h>  //!!!! insert vfw32.lib in project cam_properties configuration Linker-Input 

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#pragma warning(disable:4996)

extern int iFlagLeftRight;
int iPictureNr=1;

#define ImageX 600  
#define ImageY 480

unsigned char arrImage1 [4 * ImageX * ImageY];	
unsigned char arrImage2 [4 * ImageX * ImageY];	

BITMAPINFO	bmpinfo;
CBitmap capture_map; 
int iBitmapFlag=0;

CWin2Dlg  dlgWin2;   // like a pointer to CWin2Dlg class
extern CRect RectWin2;


CCam04Dlg::CCam04Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCam04Dlg::IDD, pParent)
{
    bmpinfo.bmiHeader.biSize		= sizeof(BITMAPINFOHEADER);
    bmpinfo.bmiHeader.biWidth		= ImageX;
    bmpinfo.bmiHeader.biHeight		= ImageY;
    bmpinfo.bmiHeader.biPlanes		= 1;
    bmpinfo.bmiHeader.biBitCount		= 32;
    bmpinfo.bmiHeader.biCompression		= BI_RGB;
    bmpinfo.bmiHeader.biSizeImage		= 0;
    bmpinfo.bmiHeader.biXPelsPerMeter	= 0;
    bmpinfo.bmiHeader.biYPelsPerMeter	= 0;
    bmpinfo.bmiHeader.biClrUsed			= 0;
    bmpinfo.bmiHeader.biClrImportant	= 0;

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCam04Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CCam04Dlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUT_SAVE_JPG, &CCam04Dlg::OnBnClickedButSaveJpg)
	ON_BN_CLICKED(IDC_BUT_JPG_NR, &CCam04Dlg::OnBnClickedButJpgNr)
END_MESSAGE_MAP()



BOOL CCam04Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			
	SetIcon(m_hIcon, FALSE);


	hMyWindow = capCreateCaptureWindow("handle", WS_CHILD | WS_VISIBLE, 0, 0, ImageX, ImageY, this->m_hWnd, 1);

    // connect the driver with the webcam 
	BOOL xx = capDriverConnect(hMyWindow,0);
    if(xx == false)
	{
		AfxMessageBox("Webcam not found ",0,0);
		return false;
	}

   //==== create and shows the second dialog window =========
	dlgWin2.Create(IDD_WIN2,this);
	dlgWin2.ShowWindow(SW_SHOW);

	//----------- Set the Timer to grab new images -----------
	SetTimer(1,40,0);

	return TRUE;  
}


void CCam04Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); 

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);


		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CCam04Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CCam04Dlg::OnTimer(UINT_PTR nIDEvent)
{
	if(nIDEvent != 1)	{ 	CDialog::OnTimer(nIDEvent); return; }


    capGrabFrame(hMyWindow);
	
	CDC *dc = GetDC(); 
	CDC     capture_dc; 

	if(iBitmapFlag==0) // create a Bitmap only once 
	{
	capture_map.CreateCompatibleBitmap( dc , ImageX, ImageY ); 
	iBitmapFlag=1;
	}

	capture_dc.CreateCompatibleDC( dc ); 
	capture_dc.SelectObject( &capture_map ); 
	capture_dc.BitBlt( 0, 0, ImageX, ImageY, dc, 0, 0, SRCCOPY );  //copy image to bitmap 

	
	//======= copy the image from bitmap to memory (arrImage1)===============
	LPBYTE lpBits = arrImage1;   // pointer 
    int xx,err;
	xx = GetDIBits(capture_dc, capture_map, 0, ImageY, lpBits, &bmpinfo, DIB_RGB_COLORS);
	if(xx == 0)   err = GetLastError(); // only for debug

	capture_dc.DeleteDC();
	ReleaseDC(dc);

	
  //*********** copy data from arrImage1 to arrImage2 *********************
	int iLine,iCol,index1,index2;
	int ii=0;
	int iimax = sizeof(arrImage1);
    
	if(iFlagLeftRight == 0)
	{
		while( ii < iimax)
		{
		arrImage2[ii] = arrImage1[ii];
        ii++;
		}
	}
	if(iFlagLeftRight == 1)
	{
     iLine=0;
	 while(iLine < ImageY)
	 {
      iCol=0;
		index1 = iLine * ImageX * 4;
		index2 = index1 + ImageX * 4 - 4;

	  while(iCol < ImageX)
	  {
		arrImage2[index2]   = arrImage1[index1++];
		arrImage2[index2+1] = arrImage1[index1++];
		arrImage2[index2+2] = arrImage1[index1++];
		arrImage2[index2+3] = arrImage1[index1++];
        index2 -= 4;
		iCol++;
	  }
	  iLine++;
	 }
	}

	dlgWin2.InvalidateRect(RectWin2,false); // repaint WIN2  with arrImage2
	
}


void CCam04Dlg::OnBnClickedButSaveJpg()
{
	capFileSaveDIB(hMyWindow,"c:\\xx.jpg");
}





void CCam04Dlg::OnBnClickedButJpgNr()
{
char cxLocalDirectory[256];
char cxFileAndPathName[256];

  memset(cxLocalDirectory,0,sizeof(cxLocalDirectory));
 _getcwd(cxLocalDirectory, sizeof(cxLocalDirectory));


sprintf(cxFileAndPathName,"%s//image%02d.jpg",cxLocalDirectory,iPictureNr);
iPictureNr++;

capFileSaveDIB(hMyWindow,cxFileAndPathName);
}


